package ballerina.data.sql;

import ballerina.doc;

@doc:Description { value:"Native Client Client Connector"}
connector ClientConnector (map options) {

	native action close (ClientConnector c);

	native action select (ClientConnector c, string query, Parameter[] parameters) (datatable);

	native action call (ClientConnector c, string query, Parameter[] parameters) (datatable);

	native action updateWithGeneratedKeys (ClientConnector c, string query, Parameter[] parameters) (int, string[]);

	native action updateWithGeneratedKeys (ClientConnector c, string query, Parameter[] parameters, string[] keyColumns) (int, string[]);

	native action batchUpdate (ClientConnector c, string query, Parameter[][] parameters) (int[]);

	native action update (ClientConnector c, string query, Parameter[] parameters) (int);

}